Subject: RE: Question on TLVs

From: manikantan <[email-masked]>
Date: Fri, 23 Jun 2000 12:36:02 +0530

Hello Robert

(Reference Section 3.1 LDP PDUs in draft-ietf-mpls-ldp-07.txt)
A LDP PDU transmitted by an LSR/LER will have in its start the
three information fields Version, PDU Length and the LDP Identifier.

After the first 10 bytes, the PDU will contain one or more
LDP Messages. 

(Reference Section 3.5 LDP Messages in draft-ietf-mpls-ldp-07.txt)
A message is uniquely identified with the three information fields
Message type, Message Length and Message ID.

Following the Message information the message related TLVs will
be available.

I have placed below set of PDU dumps and its interpretations.
In my example all the PDUs has only one message.

******************************************************************
LDP PDU with  INIT Message 

0x00 0x01 0x00 0x20 0x0a 0x01 0x05 0x01 0x00 0x00 
0x02 0x00 0x00 0x16 0x00 0x00 0x00 0x0c 0x05 0x00 
0x00 0x0e 0x00 0x01 0x00 0x3c 0xc0 0x20 0x10 0x00 
0x0a 0x05 0x04 0x05 0x00 0x00 

LDP: ---------------------------------------------
LDP: LDP PDU HDR CONTENTS : 
LDP: LDP Version      : 1 
LDP: LDP PduLen       : 32 
LDP: LDP Id           : 0xa:1:5:1:0:0 
LDP: LDP MSG HDR CONTENTS : 
LDP: LDP Msg Type     : 0x200 - Ldp Init Msg.
LDP: LDP Msg Len      : 22 
LDP: LDP Msg Id       : 12 
LDP: TLV Type         : 0x500  - CmnSsnParmsTlv.
LDP: TLV Length       : 14 
LDP: LDP Version      : 1
LDP: Keep Alive Time  : 60
LDP: Advt_Loop Inf    : 0xc0
LDP: Advt Type        : DOD.
LDP: Loop Detection   : Enabled. 
LDP: Path Vect Limit  : 32
LDP: Max PDU Length   : 4096
LDP: Rcvr LDP Id      : 0xa:0x5:0x4:0x5:0:0 
LDP: ---------------------------------------------
******************************************************************
LDP PDU with Keep Alive Message 

0x00 0x01 0x00 0x0e 0x0a 0x01 0x05 0x01 0x00 0x00 
0x02 0x01 0x00 0x04 0x00 0x00 0x00 0x10 

LDP: ---------------------------------------------
LDP: LDP PDU HDR CONTENTS : 
LDP: LDP Version      : 1 
LDP: LDP PduLen       : 14 
LDP: LDP Id           : 0xa:1:5:1:0:0 
LDP: LDP MSG HDR CONTENTS : 
LDP: LDP Msg Type     : 0x201 - Keep Alive Msg.
LDP: LDP Msg Len      : 4 
LDP: LDP Msg Id       : 16 
LDP: ---------------------------------------------
******************************************************************
LDP PDU with Address message

0x00 0x01 0x00 0x18 0x0a 0x01 0x05 0x01 0x00 0x00 
0x03 0x00 0x00 0x0e 0x00 0x00 0x00 0x14 0x01 0x01 
0x00 0x06 0x00 0x01 0x0a 0x01 0x05 0x01 

LDP: ---------------------------------------------
LDP: LDP PDU HDR CONTENTS : 
LDP: LDP Version      : 1 
LDP: LDP PduLen       : 24 
LDP: LDP Id           : 0xa:1:5:1:0:0 
LDP: LDP MSG HDR CONTENTS : 
LDP: LDP Msg Type     : 0x300 - Addr Msg 
LDP: LDP Msg Len      : 14 
LDP: LDP Msg Id       : 20 
LDP: LDP TLV Type     : 0x101 - AddrList TLV.
LDP: LDP TLV Len      : 6  
LDP: Addr Family      : 1 - IPv4 
LDP: Addr - 1        : 0xa010501  
LDP: ---------------------------------------------
******************************************************************
LDP PDU with Label Request Message

0x00 0x01 0x00 0x26 0x0a 0x01 0x05 0x01 0x00 0x00 
0x04 0x01 0x00 0x1c 0x00 0x00 0x00 0x15 0x01 0x00 
0x00 0x07 0x02 0x00 0x01 0x18 0x0a 0x03 0x04 0x01 
0x03 0x00 0x01 0x01 0x01 0x04 0x00 0x04 0x0a 0x01 
0x05 0x01 

LDP: ---------------------------------------------
LDP: LDP PDU HDR CONTENTS : 
LDP: LDP Version      : 1 
LDP: LDP PduLen       : 38 
LDP: LDP Id           : 0xa:1:5:1:0:0 
LDP: LDP MSG HDR CONTENTS : 
LDP: LDP Msg Type     : 0x401 - Lbl Req Msg 
LDP: LDP Msg Len      : 28 
LDP: LDP Msg Id       : 21 
LDP: TLV Type         : 0x100 - FEC Tlv  
LDP: TLV Len          : 7 
LDP: FEC Type         : 0x2  - Prefix Type.
LDP: Addr Fmly        : 0x1  - IPv4.
LDP: Prefix Len       : 0x18
LDP: Prefix           : 0xa0304
LDP: TLV Type         : 0x103  - HopCount TLV.
LDP: Tlv Length       : 1
LDP: Hop Count val    : 1
LDP: TLV Type         : 0x104  - Path Vector TLV.
LDP: Tlv Length       : 4
LDP: LSR ID - 64      : 0xa010501
LDP: ---------------------------------------------

******************************************************************
LDP PDU with Label Map message.

0x00 0x01 0x00 0x36 0x0a 0x01 0x05 0x01 0x00 0x00 
0x04 0x00 0x00 0x2c 0x00 0x00 0x00 0x1a 0x01 0x00 
0x00 0x07 0x02 0x00 0x01 0x18 0x14 0x00 0x06 0x02 
0x00 0x00 0x04 0x00 0x00 0x00 0x10 0x06 0x00 0x00 
0x04 0x00 0x00 0x00 0x1d 0x01 0x03 0x00 0x01 0x01 
0x01 0x04 0x00 0x04 0x0a 0x01 0x05 0x01 

LDP: ---------------------------------------------
LDP: LDP PDU HDR CONTENTS : 
LDP: LDP Version      : 1 
LDP: LDP PduLen       : 54 
LDP: LDP Id           : 0xa:1:5:1:0:0 
LDP: LDP MSG HDR CONTENTS : 
LDP: LDP Msg Type     : 0x400 - Lbl Map Msg 
LDP: LDP Msg Len      : 44 
LDP: LDP Msg Id       : 26 
LDP: TLV Type         : 0x100 - FEC Tlv  
LDP: TLV Len          : 7 
LDP: FEC Type         : 0x2  - Prefix Type.
LDP: Addr Fmly        : 0x1  - IPv4.
LDP: Prefix Len       : 0x18
LDP: Prefix           : 0x140006
LDP: TLV Type         : 0x200  - Gen Lbl TLV.
LDP: Tlv Length       : 4 
LDP: Label Value      : 0x10
LDP: TLV Type         : 0x600  - LblReqMsgId TLV.
LDP: Tlv Length       : 4
LDP: LblReqMsgId val  : 29
LDP: TLV Type         : 0x103  - HopCount TLV.
LDP: Tlv Length       : 1
LDP: Hop Count val    : 1
LDP: TLV Type         : 0x104  - Path Vector TLV.
LDP: Tlv Length       : 4
LDP: LSR ID - 1      : 0xa010501
LDP: ---------------------------------------------
******************************************************************

Hope this helps

with best regards
mani
 
/*-------------------------------------------------------------------*/
S.Manikantan
Future Software Private Limited
480-481, Anna salai, Nandanam,
Chennai, Tamil Nadu, 600 035,
India.
Phone	: +91-44-4330550
Fax	: +91-44-4344157.
Email	: [email-masked]
http://www.futsoft.com
/*--------------------------------------------------------------------*/

-----Original Message-----
From:	Robert Streijl [SMTP:[email-masked]]
Sent:	Friday, June 23, 2000 3:50 AM
To:	[email-masked]
Subject:	Question on TLVs

Hi,

I am fairly new to MPLS and I am currently reading through the produced drafts.
I bumped into Type Length Values used for encoding.
I started with the architecture and then started reading the LDP spec, but I
still don't get it.

I understand that LDP PDUs can contain multiple messages. I also understand that
there are different message types, but I don't understand the role of TLVs.
The TLVs show byte allocations, so I am wondering if it goes in the LDP PDU or
LDP messages. First I thought it is appended to the LDP PDU header, then I
thought it is one of the fields in each of the messages. However, the TLV
messages are bigger than the reserved space in the LDP messages.

Is this encoding information somehow stored in a different way, not in the LDP
messages/PDUs?

Can somebody please help me understand this?

Thanks very much in advance.

Regards,
Robert